import numpy as np
import scipy as sp
import os
import matplotlib.pyplot as plt

##################################
# 1 - Load The Data to Analyze ###
##################################
# Specify the Directory where the data are

# # Specify the file name of the data you want to analyze
#Data_x = os.path.join(directory,'2022-03-01_14_43_Surface_234424_57_GHz_2_2uW_520nm_14uW_after_realignment_after_optimizing_focus_X')
#
# # Load the data
# x_values = np.loadtxt(Frequency_x)
# y_values = np.loadtxt(Counts_y)

#C:\Users\pc2009\Dropbox (Heriot-Watt University Team)\RES_EPS_Quantum_Photonics_Lab\Papers\2022 - vanadium inhomogeneous broadening\Fig1\PL_Map\Data
#2022-03-01_14_43_Surface_234424_57_GHz_2_2uW_520nm_14uW_after_realignment_after_optimizing_focus_X
directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PL_Maps_Resonant/'

Data_x = os.path.join(directory,'2022-03-01_14_43_Surface_234424_57_GHz_2_2uW_520nm_14uW_after_realignment_after_optimizing_focus_X.txt')
Data_y = os.path.join(directory,'2022-03-01_14_43_Surface_234424_57_GHz_2_2uW_520nm_14uW_after_realignment_after_optimizing_focus_Y.txt')
Data_z = os.path.join(directory,'2022-03-01_14_43_Surface_234424_57_GHz_2_2uW_520nm_14uW_after_realignment_after_optimizing_focus_Z.txt')

# # Load the data
X = np.loadtxt(Data_x)
Y = np.loadtxt(Data_y)
Z = np.loadtxt(Data_z)

# Normalize The image for minimum Z value
# 1 Find the minimum
z_min = np.min(Z)
print(z_min)
# 2 Subtract the minimum from the Z
Z0 = Z - z_min

#x = XYscan.xPositions; y = XYscan.yPositions;
#[X, Y] = np.meshgrid(X, Y); [Xum, Yum] = np.meshgrid(X*5.25, Y*5.25)
#Z = XYscan.detector_readout_0.transpose()

# List of color maps: https://matplotlib.org/stable/gallery/color/colormap_reference.html
m = plt.pcolormesh(X*5.25, Y*5.25, Z0, cmap='YlOrRd', shading='auto') #'YlOrRd'
plt.xlabel('X Position ($\mu$m)', fontsize=16); plt.ylabel(r'Y Position ($\mu$m)', fontsize=16)

# Legend
#plt.clim() # set the colorbar range
cbar = plt.colorbar();
cbar.ax.set_ylabel('PL (Counts/s)', size=16, rotation=90)
# 21.04:0.5=10:x --> x = 0.2376 = 10 um
plt.axhline(y=-20, xmin=0.5, xmax=0.7376)
#cbar.ax.tick_params(labelsize=16)
#plt.colorbar().set_label(label='a label',size=15,weight='bold')
#cbar.ax.yaxis.set_ticks_position('left')

#Save the figure
#plt.savefig( 'save as pdf.pdf')
#plt.title(str(integration_time) + 'ms', fontsize=22); plt.colorbar()
#plt.savefig(fname=directory + time_stamp + '_map_um'); plt.show();
#plt.close()